import os
import cv
from scipy.io import savemat

import feature

descriptors = []
for f in os.listdir('raw'):
    if not f.endswith('.png'):
        continue
    im = cv.LoadImage('raw/%s' % f)
    descriptors.append(feature.get_surf_descriptors(im))

vocabulary = feature.build_vocabulary(descriptors, 400)
savemat('vocabulary.mat', {'vocabulary': vocabulary})
