import re
import os
import cv

import preprocess

nrepeat = 4
case_model = [0]
dest_dir = 'raw' # 'raw' for training data, 'test' for testing data

the_id = 0
pat = re.compile(r'^(?P<fn>[^:]+):.,(?P<lbl>[A-Z]{4}),.*')

def gen_raw(model):
    if os.system("mono Judge.exe -dtmp -m%d -n" % model) != 0:
        print "Error generating raw image!"

def next_id():
    global the_id
    the_id += 1
    return the_id

if not os.path.isdir('tmp'):
    os.mkdir('tmp')
if not os.path.isdir(dest_dir):
    os.mkdir(dest_dir)

for irun in range(nrepeat):
    print "Pass %d..." % irun
    for model in case_model:
        gen_raw(model)
        for l in open('tmp/judgeData.txt').readlines()[1:]:
            res = pat.match(l)
            fn = res.group('fn')
            label = res.group('lbl')

            im = cv.LoadImage('tmp/%s' % fn)
            parts = preprocess.split(preprocess.denoise(im))
            for i in range(4):
                cv.SaveImage('%s/%s-%d-%d.png' % 
                             (dest_dir, label[i], model, 
                              next_id()), parts[i])
