import math
from numpy import zeros, tile, matlib
from scipy.io import loadmat, savemat

class Model(object):
    pass

def load_model(filename):
    d = loadmat(filename)
    m = Model()
    m.x = d['x']
    m.y = d['y']
    m.nclass = d['nclass']
    return m

def save_model(filename, model):
    savemat(filename, {'x':model.x, 'y':model.y, 'nclass':model.nclass})
    

def classify(vec, model, k):
    tmp = tile(vec, (model.x.shape[0], 1))-model.x
    dist = matlib.sum(tmp*tmp, axis=1)
    idx = dist.argsort()
    votes = zeros(model.nclass)
    for i in idx[:k]:
        votes[int(model.y[i])] += math.exp(-dist[i])
    return votes.argmax()
