import cv

def denoise(im):
    im_gray = cv.CreateImage(cv.GetSize(im), cv.IPL_DEPTH_8U, 1)
    cv.CvtColor(im, im_gray, cv.CV_RGB2GRAY)

    im_blur = cv.CreateImage(cv.GetSize(im), cv.IPL_DEPTH_8U, 1)
    cv.Smooth(im_gray, im_blur, cv.CV_MEDIAN, 5)

    im_result = cv.CreateImage(cv.GetSize(im), cv.IPL_DEPTH_8U, 1)
    cv.Threshold(im_blur, im_result, 250, 255, cv.CV_THRESH_BINARY)
    #cv.Copy(im_blur, im_result)

    return im_result

hacc_thresh = 8
vacc_thresh = 5
def split(im):
    def is_empty_column(i):
        vacc = 0
        for j in range(im.height):
            if im[j, i] != 255:
                vacc += 1
        if vacc > vacc_thresh:
            return False
        return True

    def get_region(x, x1):
        subim = cv.CreateImage((x1-x, 50), cv.IPL_DEPTH_8U, 1)
        region = cv.GetSubRect(im, (x, 0, x1-x, 50))
        cv.Copy(region, subim)
        return subim

    results = []
    x = 0
    for i in range(3):
        x1 = x
        while x1 < 200:
            if is_empty_column(x1): x1 += 1
            else: break
        # assume a letter has minimum width
        x1 += 25

        local_hacc_thresh = hacc_thresh
        while local_hacc_thresh >= 0:
            local_x1 = x1
            hacc = 0
            found = False
            while local_x1 < 200:
                if is_empty_column(local_x1):
                    hacc += 1
                    if hacc > local_hacc_thresh:
                        found = True
                        break
                local_x1 += 1
                if local_x1 - x > 55:
                    break
            if found: break
            else: local_hacc_thresh -= 1
        if found: x1 = local_x1
        else: 
            cv.SaveImage('split_failed.png', im)
            raise Exception('This should never happen')

        results.append(get_region(x, x1))
        x = x1
    results.append(get_region(x, 200))

    return results

