import os
import cv
import sys
from scipy.io import loadmat
from numpy import zeros

import feature
import pca_feature
import knn

model = knn.Model()
model.nclass = 26

if len(sys.argv) < 3:
    print 'Usage: '
    print '    %s [pca|surf] image_dir model_file [options...]' % sys.argv[0]
    sys.exit(0)
fea_type = sys.argv[1]
basedir = sys.argv[2]
modelfile = sys.argv[3]

files = []
for f in os.listdir(basedir):
    if f.endswith('.png'):
        files.append(f)

model.y = zeros(len(files))

if fea_type == 'surf':
    vocabulary = loadmat('vocabulary.mat')['vocabulary']
    model.x = zeros((len(files), vocabulary.shape[0]))
else:
    coef_file = sys.argv[4]
    coef = pca_feature.load_coef(coef_file)
    model.x = zeros((len(files), coef.shape[1]))

i = 0
for f in files:
    im = cv.LoadImage('%s/%s' % (basedir, f))
    model.y[i] = ord(f[0])-ord('A')
    if fea_type == 'surf':
        model.x[i] = feature.vectorize_sample(im, vocabulary)
    else:
        model.x[i] = pca_feature.vectorize_sample(im, coef)
    i += 1

knn.save_model(modelfile, model)
