import os
import sys
import cv
from scipy.io import loadmat

import knn
import feature
import pca_feature

input = sys.argv[1]
fea_type = sys.argv[2]
modelfile = sys.argv[3]
extrafile = sys.argv[4]

knn_k = 5
if fea_type == 'surf':
    vocabulary = loadmat(extrafile)['vocabulary']
else:
    coef = pca_feature.load_coef(extrafile)
model = knn.load_model(modelfile)


ngood = 0
nbad = 0
bad_files = []
for f in os.listdir(input):
    if not f.endswith('.png'):
        continue
    im = cv.LoadImage('%s/%s' % (input, f))
    if fea_type == 'surf':
        vec = feature.vectorize_sample(im, vocabulary)
    else:
        vec = pca_feature.vectorize_sample(im, coef)
    lbl = knn.classify(vec, model, knn_k)
    lbl = chr(ord('A')+lbl)
    if lbl == f[0]:
        ngood += 1
        sys.stdout.write('\033[1;32m.\033[0m')
    else:
        nbad += 1
        sys.stdout.write('\033[1;31m.\033[0m')
        bad_files.append((f, lbl))
print
print 'Failed instances: '
for f, lbl in bad_files:
    print '%s: %s' % (f, lbl)
print 'accuracy = %.2f%%' % (ngood*100.0/(ngood+nbad))
